function geom
% $$$ Blaise Pascal University
% geom.m
% $$$ Voila un couple d'images.
% $$$ Pour les camera :
% $$$ 
% $$$ u0 = 800
% $$$ v0 = 600
% $$$ 
% $$$ focale = 1750
% $$$ 
% $$$ Le repere du monde est situe sur l'axe reliant les deux cameras.
% $$$ la camera gauche   pour coordonne :
% $$$ { -2 0 0 }
% $$$ 
% $$$ la camera droite :
% $$$ { 2 0 0 }
% $$$ 
% $$$ La camera gauche fait un angle de -20  avec OY (Cam1)
% $$$ La camera droite fait un angle de 20  avec OY (Cam2)


% Chargement de l'image
%%%%%%%%%%%%%%%%%%%%%%%
%Image 1 (camra gauche)
clear;
[I1,map1]=imread('cam1.tif');
I1=I1(:,:,1);
image(I1);
colormap(gray(256));
%% Dfinition des paramtres extrinsecs
%% On dfinit le reprre monde au centre de l'objet
%%%%%%%%%%%%%%%%%%%%%%
% A remplir par l'tudiant
% Mext = ...
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Paramtres intrinsecs de la camra
f=1750;
u0=800;
v0=600;
% Matrice des paramtres intrinsques
%%%%%%%%%%%%%%%%%%%%%%%
% Aremplir par l'tudiant
%K= ...

% Matrice totale :
%%%%%%%%%%%%%%%%%%%
% A remplir par l'tudiant
% P= ... 


%%%%%%%%%%%%%%%%%%%%%
% Projection des points
p1=[-0.5 ; 0.5 ; -0.5 ; 1]
PrPlot(p1,P,'+r');

%% Fonctions diverses
function Ry=roty(t)
Ry=[cos(t) ,0 ,sin(t) ,0 ; ...
   0 ,1 ,0 ,0 ; ...
   -sin(t) ,0 ,cos(t) ,0 ; ...
   0 ,0 ,0 ,1];

function Rx=rotx(t)
Rx=[1 ,0 ,0 ,0 ; ...
   0, cos(t)  ,-sin(t)  ,0 ; ...
   0, sin(t), cos(t), 0 ; ...
   0, 0, 0, 1];

function Rz=rotz(t)
Rz=[cos(t), -sin(t), 0, 0 ; ...
    sin(t),  cos(t), 0, 0 ; ...
    0, 0, 1, 0 ; ...
    0, 0, 0, 1];

function T=trans(x,y,z)
T=[1 0 0 x ; ...
   0 1 0 y ; ...
   0 0 1 z; ...
   0 0 0 1];

% Convertion Degres/Radians
function r=DR(d)
r=d*pi/180;
% Projection et affichage de  points 
function PrPlot(p1,Tr,s);
% p1 :liste des points 3D a afficher
%     en colonne et coordonnees homogenes
% Tr :Matrice de projection camera
% s : string de style d'affichage des points (ex : '*r')
pi1=Tr*p1
pi1=pi1(1:2,:)./(repmat(pi1(3,:),1));
hold on;
plot(pi1(1,:),pi1(2,:),s);
hold off